#include <Adafruit_GFX.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_ILI9341.h>
#include <Adafruit_TSC2007.h>

#define TS_MINX 150
#define TS_MINY 130
#define TS_MAXX 3800
#define TS_MAXY 4000
#define TS_MIN_PRESSURE 100
Adafruit_TSC2007 ts;

#define TFT_CS 10
#define TFT_DC 9
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);

#define BOXSIZE 80
int oldcolor, currentcolor;

// Bat variables
#define BAT_WIDTH 40
#define BAT_HEIGHT 10
int batX, batY;

void setup() {
  Serial.begin(115200);
  
  tft.begin();
  if (!ts.begin()) {
    Serial.println("Couldn't start touchscreen controller");
    while (1);
  }
  Serial.println("Touchscreen started");

  tft.fillScreen(ILI9341_BLACK);
  tft.fillRect(0, 0, BOXSIZE, BOXSIZE, ILI9341_RED);
  currentcolor = ILI9341_RED;

  // Initialize bat position
  batX = (tft.width() - BAT_WIDTH) / 2;
  batY = tft.height() - 20; // Adjust this value according to your preference
}

bool isBlue = false;

void loop() {
  uint16_t x, y, z1, z2;
  if (ts.read_touch(&x, &y, &z1, &z2) && (z1 > TS_MIN_PRESSURE)) {
    // Clear the previous bat position
    tft.fillRect(batX, batY, BAT_WIDTH, BAT_HEIGHT, ILI9341_BLACK);

    // Map touchscreen coordinates to bat position
    batX = map(x, TS_MINX, TS_MAXX, 0, tft.width() - BAT_WIDTH);

    // Draw the bat in its new position
    tft.fillRect(batX, batY, BAT_WIDTH, BAT_HEIGHT, ILI9341_WHITE);

    Serial.print("Touch point: (");
    Serial.print(x); Serial.print(", ");
    Serial.print(y); Serial.print(", ");
    Serial.print(z1); Serial.print(" / ");
    Serial.print(z2); Serial.println(")");
  }
}